//  File:  ValRef.cpp

#include <iostream.h>

/*==============================================================================*/

void ByValue (int nValue)
{
    cout << "ByValue:      nValue  = " << nValue << endl;
    nValue = 3 * nValue;
    cout << "ByValue:      nValue  = " << nValue << endl;
}

/*==============================================================================*/

void ByReference (int& nrValue)
{
    cout << "ByReference:  nrValue = " << nrValue << endl;
    nrValue = 3 * nrValue;
    cout << "ByReference:  nrValue = " << nrValue << endl;
}

/*==============================================================================*/

int main (void)
{
    cout << endl 
         << "The difference between call by value and call by reference" << endl 
         << endl;

    int  nValue = 10;
    cout << "Main:         nValue  = " << nValue << endl;
    ByValue (nValue);
    cout << "Main:         nValue  = " << nValue << "  UNCHANGED" << endl 
         << endl;

    int  nrValue = 20;
    cout << "Main:         nrValue = " << nrValue << endl;
    ByReference (nrValue);
    cout << "Main:         nrValue = " << nrValue << "  CHANGED" << endl 
         << endl;

    return 0;
}

/*==============================================================================*/

/* ..... Output from the program .....

The difference between call by value and call by reference

Main:         nValue  = 10
ByValue:      nValue  = 10
ByValue:      nValue  = 30
Main:         nValue  = 10  UNCHANGED

Main:         nrValue = 20
ByReference:  nrValue = 20
ByReference:  nrValue = 60
Main:         nrValue = 60  CHANGED

..... end of output ..... */

